
#include "encoder.h"

void encoder_init(uint32_t max_value)
{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;
	RCC->APB1ENR|=RCC_APB1ENR_TIM2EN;
	GPIOA->MODER|=GPIO_MODER_MODER0_1|GPIO_MODER_MODER1_1;
	GPIOA->MODER&=~(GPIO_MODER_MODER0_0|GPIO_MODER_MODER1_0);
	#define AF01 0x01
	GPIOA->AFR[0]|=(AF01<<GPIO_AFRL_AFRL0_Pos)|(AF01<<GPIO_AFRL_AFRL1_Pos);

	TIM2->ARR = max_value;

	TIM2->CCMR1 |= (TIM_CCMR1_CC1S_0 | TIM_CCMR1_CC2S_0 );
	TIM2->CCER &= ~(TIM_CCER_CC1P | TIM_CCER_CC2P);
	TIM2->SMCR |= TIM_SMCR_SMS_0 | TIM_SMCR_SMS_1;
	TIM2->CR1 |= TIM_CR1_CEN;
	TIM2->CNT=0;
	TIM2->EGR|=TIM_EGR_UG;
}


uint32_t read_encoder(void)
	{

		return TIM2->CNT;

	}
